#include <stdio.h>
#include <omp.h>

#define N 10

// Assumes n > 0
int fibonacci( int n )
{
    int x, y;

    if (n < 2) 
        return 1;
    // x, y, n: shared
    #pragma omp task shared(x)
    x = fibonacci(n-1);
    #pragma omp task shared(y)
    y = fibonacci(n-2); 
    #pragma omp taskwait
    printf("[%d] fib(%d) = %d\n", omp_get_thread_num(), n, x + y);
    return x + y;
}

int main ( void )  
{
  int i;
  int fib[N];

  #pragma omp parallel for
  for( i = 0 ; i < N; i++ )
      #pragma omp task
      fib[i] = fibonacci(i);

  // Print out the Fibonacci numbers
  printf("[%d", fib[0]);
  for( i = 1 ; i < N; i++ )
      printf(", %d", fib[i]);
  printf("]\n");

  return 0;
}
